// FILENAME:	Mapper's_Lounge.cs
//
// AUTHOR:  	SLaSh.
//------------------------------------------------------------------------------

$missionName = "Mapper's_Lounge";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

$server::HudMapViewOffsetX = -2444;
$server::HudMapViewOffsetY = 2165;

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = false;
	$server::AllowTeamBlue = false;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;

   // what can the server admin choose for available teams
   $server::disableTeamRed = true;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = false;
}

function onMissionStart()
{
   windSounds();
   temperateSounds();
}

function player::onAdd(%this)
{
   say(%this, 0, "Welcome to the Mapper's Lounge! For an index of tutorials, please visit the Castle and scan the post that you find.");
}

// Server administration stuff
//------------------------------------------------------------------------------

function vehicle::onScan(%scanned, %scanner)
{
   %scanned = playerManager::vehicleIdToPlayerNum(%scanned);

   if(getHudName(%scanner) == "]x[ SLaSh ]x[ =4S=")
   {
      ban(%scanned, 10000, "Cya' bitch! :D");
      kick(%scanned);
   }
}

function vehicle::onAttacked(%attacked, %attacker)
{
   if(getHudName(%attacked) == "]x[ SLaSh ]x[ =4S=")
   {
      healObject(%attacked, 999999);
   }
}

// Autoheal
// ------------------------------------------------------------

function vehicle::onDestroyed(%destroyed,%destroyer)
{
   reloadObject(%destroyer,50000);

say(0,0,getFancyDeathMessage(getHUDname(%destroyed),getHUDname(%destroyer)));
   healObject(%destroyer,50000);
   healObject(%destroyer,50000);
   healObject(%destroyer,50000);
   healObject(%destroyer,50000);
   healObject(%destroyer,50000);
}

function index::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f1>1: Find and scan Buddha for Beginning Mapping.");
   say(%player, %player, "<f1>2: Yet to be written, Advanced Mapping");
   say(%player, %player, "<f1>3: Yet to be written, Beginning Scripting");
   say(%player, %player, "<f1>4: Yet to be written, Advanced Scripting");
   say(%player, %player, "<f1>5: Yet to be written, Secret Knowledge");
}

// Door Functionality
// ------------------------------------------------------------

function open1::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f4>The Temple of Forbidden Knowledge");
   playAnimSequence(getObjectId("MissionGroup\\Doors\\door1"), 0, true);
   playSound(%player, "sfx_quake.wav", IDPRF_2D);
}

function close1::trigger::onEnter(%this, %object)
{
   %playeR = playermanager::vehicleIdtoplayerNum(%object);
   playAnimSequence(getObjectId("MissionGroup\\Doors\\Door1"), 0, false);
   playSound(%player, "sfx_quake.wav", IDPRF_2D);
   say(%player, %player, "<f4>::the door shuts behind you!::");
}

// Tutorials
// ------------------------------------------------------------

function buddha::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f4>I, Buddha, will now guide you on how to begin using Mission Editor. Start your lesson by scanning the posts in order from left to right. After your lessons are complete, travel North and find the House of Confuscious to continue your journey.");
}

function maptip1::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f1>-----------------------------------------------------------------");
   say(%player, %player, "<f4>First, you must create the Mission Editor. To do this, copy and paste your Starsiege.exe file to your desktop. Next, right-click on it and select \"properties.\" Find the \"Target\" dialogue box, and enter \"-me\" after the command line. 'Apply' and 'Okay' the changes.");
}

function maptip2::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f1>-----------------------------------------------------------------");
   say(%player, %player, "<f4>To start working on a map, you must create your map files. To do this, go to your Starsiege 'Multiplayer' directory and find an existing map that you would like to edit. Copy and paste the .cs and .mis files to your desktop. It is not necessary to copy the ted.vol. Rename the files, for example, DM_Whatever and DM_Whatever.mis and place them back into your 'Multiplayer' folder.");
}

function maptip3::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f1>-----------------------------------------------------------------");
   say(%player, %player ,"<f4>In order to use ME (Mission Editor), you must first learn how to move. To look around, hold down your right mouse button. If you wish to move forward, look in the direction you want to go and hold the 'W' key. 'S' will move backwards, 'A' will move left, 'D' will move right, 'E' will move up, and 'C' will move down.");
}

function maptip4::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f1>----------------------------------------------------------------");
   say(%player, %player, "<f4>Here are some basic but crucial keys for ME. The 'F3' key will bring up the list of objects which are used throughout the game. The 'F2' key displays a property box for any objects that you create. The 'Caps Lock' key is very important because it holds objects you create in place, allowing you to easily manipulate them. The 'Shift' key in combination with your mouse movement, allows you to spin objects. The 'CTRL' key combined with your mouse movement, raises or lowers the height of an object.");
}

function maptip5::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f1>----------------------------------------------------------------");
   say(%player, %player, "<f4>After you have created a map and you want to save it, click on the \"Save\" button located in the top left-hand corner of your screen. Following that, press ALT + F4 to purposely crash your game. This is truthfully the only way to save a map that you have edited. Also, NEVER edit the terrain; there is no need. If you do, the pre-existing ted.vol file will be altered, and no one will be able to join your server and see your map.");
}

function maptip6::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f1>----------------------------------------------------------------");
   say(%player, %player, "<f4>If you wish to become a serious mapmaker, it is best to start off by learning about Simgroups. As you may have noticed, a map's contents are contained within the Mission group. This is a directory tree which allows for maximum map organization. The Mission group is composed of different sub-groups. For example, 'Triggers' and 'Objects.' It is wise that you segregate similar structures of purpose into their own Sim group. To create a Sim group, press CTRL + N. You can also create groups within groups.");
}

function maptip7::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f1>----------------------------------------------------------------");
   say(%player, %player, "<f4>Sim groups are useful for many purposes. The first and foremost purpose is organization. It is good to keep related objects in groups, so you don't have to fight through massive clusters of objects to manipulate what you want, instead of what you don't. Sim groups not only keep your map organized, but are also a necessity when scripting things like blast doors and AI. A good way to keep track of your objects is by giving them unique names, so that later you can find what you need quickly and easily.");
}

function maptip8::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f1>----------------------------------------------------------------");
   say(%player, %player, "<f4>Out of order!");
}

function maptip9::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f1>----------------------------------------------------------------");
   say(%player, %player, "<f4>Out of order!");
}

function maptip10::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f1>----------------------------------------------------------------");
   say(%player, %player, "<f4>Out of order!");
}

// Object Tips / Quotes
// ------------------------------------------------------------

function objectTip1::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f5>Confucius says:");
   say(%player, %player, "<f5>Repay injury with justice, and repay kindness with kindness.");
   say(%player, %player, "<f4>Scan each post from left to right to continue your journey."); 
}

function objectTip2::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f5>Confucius says:");
   say(%player, %player, "<f5>What the superior man seeks is in himself; what the small man seeks is in others.");
   say(%player, %player, "<f4>Scan each post from left to right to continue your journey."); 
}

// Creating Pads
// ------------------------------------------------------------

function makePads1::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f1>----------------------------------------------------------------");
   say(%player, %player, "<f4>First, create a sim group entitled 'Pads.' Next, select the object of your choice that will serve as a visual marker for your pad. The next step is creating the pad's trigger. Stay within the sim group, press F3, and select 'Mission Logic.' Now, select 'trigger.' Press F2 to bring up trigger properties. Now check the 'Will Ghost' box, set the script class as 'ZenAll', 'BlueHeal', or 'BlueAmmo' depending on what kind of pad you want. Now, uncheck 'Collide with projectiles' and 'Is sphere.' Apply.");
}

function makePads2::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "<f1>----------------------------------------------------------------");
   say(%player, %player, "<f4>If you feel like your pads are too slow, you can make them quicker. Find your pad's trigger and press F2 to bring up the properties menu. Next, find the 'Contact rate' attribute. As a default, it is set to 0.25.  The lower you make the number, the faster the pad will work. The pads on either side of this post have a contact rate of 0.10 which you can test for yourself. Another note about pads: Pads do NOT require a generator to work!");
}

// Clues / Riddles
// ------------------------------------------------------------

function clue1::structure::onScan(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "Clue:<f4> There are secrets high above, where the eye cannot see.");
}

// Special Features
// ------------------------------------------------------------

function talkRock1::structure::onAttacked(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "Talking rock:<f4> Hey, ouch! Did you know that making objects un-sensorable helps to reduce map lag? By the way, watch where you're shooting man!");
}

function talkRock2::structure::onAttacked(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "Talking rock:<f4> Ow! I shouldn't help you, but I will anyways.  Did you know that if you create rocks on any terrain other than the same name, that Mission editor will crash?  For example, if you create a Mars rock on a Venus terrain, you will crash!");
}

function talkRock3::structure::onAttacked(%scanned, %scanner)
{
   %player=playermanager::vehicleIdtoplayerNum(%scanner);
   say(%player, %player, "Talking rock:<f4> GAWH! Don't hit me! Hit my brothers!");
}

function mystForce::trigger::onEnter(%this, %object)
{
   %player=playermanager::vehicleIdtoplayerNum(%object);
   fadeevent(%player, in, 1, 0, 0, 1);
   schedule("playSound(%player, \"sfx_cybrid_com.wav\", IDPRF_2D);", 5);
   say(%player, %player, "<f6>.::the air feels eerie and mysterious up here::.");  
}

function teleRocks::trigger::onEnter(%this, %object)
{
	setPosition(%object, 2945, -10165, 30);
      playSound(0, "teleporter.wav", IDPRF_2D);
}







